/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2010, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#ifndef STRUCTDNEIGH_H
#define STRUCTDNEIGH_H

/* DNeigh only applies for tessellations built from (N,Id), not
 * from a tessellation file.
 */
struct DNEIGH
{
  /* type of tessellation
   * 0: standard; 1:periodic, 2: subdomain
   */
  int ttype;

  /* General info */
  int NDensity;			/* this is equal to the value of -n */
  int Id;			/* standard id                      */

  long Random;			/* this is from domain's (N,Id) ... */

  /* Domain info */
  int N;			/* real nb of germs     */
  double *Size;			/* this MUST be [0,1]**3 */
  double Vol;			/* this MUST be 1 */
  double **GermsCoo;		/* Germs coo (these are inside the domain) */

  /* Domain neighbourhood info */
  int nN;			/* real nb of germs */
  double *nSize;		/* Size (x,y,z bounds) */
  double nVol;			/* Real volume */
  double **nGermsCoo;		/* Germs coo (these are without the domain) */
  int *nGermRandId;		/* Germs rng output id */

  int *GermToGerm;		/* This is useful for ttype=1 */

  char *oin;
};
typedef struct DNEIGH DNEIGH;

#endif /* STRUCTDNEIGH_H */
