/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2010, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"RMeshingFTess.h"

void
TessSearchEltPoly (struct TESS Tess, struct MAPMESH *pMap, int verbosity)
{
  int j, elt, pid;
  int EltQty =
    (*pMap).MeshSize[0] * (*pMap).MeshSize[1] * (*pMap).MeshSize[2];
  int m = 0;
  double *coo = ut_alloc_1d (3);

  for (elt = 1; elt <= EltQty; elt++)
  {
    for (j = 0; j < 3; j++)
      coo[j] = gsl_matrix_float_get ((*pMap).EltCoo, elt, j);

    pid = 0;
    while (gsl_vector_int_get ((*pMap).EltPoly, elt) == 0)
    {
      pid++;
      if (pid > Tess.PolyQty)
      {
	ut_print_message (2, 0, "elt does not belong to any polyhedron!\n");
	printf ("elt: id = %d coo = ", elt);
	ut_array_1d_fprintf (stdout, coo, 3, "%f");
	printf ("browsing polyhedron %d\n", pid);
	abort ();
      }

      if (InPoly (coo - 1, Tess, pid) == 1)
	gsl_vector_int_set ((*pMap).EltPoly, elt, pid);
    }

    /* print percent evolution in case of verbosity */
    if (verbosity >= 1)
      PercentDisplay (elt, EltQty, 10, &m);
  }

  ut_free_1d (coo);

  return;
}
