/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2010, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "Res_mm.h"

void
WriteMapMesh (struct IN In, struct MAPMESH Map, int **pPolyEltQty)
{
  int i, elset, PrintedElset, col;
  int EltQty = Map.MeshSize[0] * Map.MeshSize[1] * Map.MeshSize[2];

  FILE *file = NULL;

  file = ut_file_open (In.geof, "A");

  elset = 0;
  PrintedElset = 0;
  col = 1;
  for (i = 1; i <= EltQty; i++)
  {
    if (gsl_vector_int_get (Map.EltPoly, Map.EltId[i]) != elset)
    {
      elset = gsl_vector_int_get (Map.EltPoly, Map.EltId[i]);
      PrintedElset++;
      fprintf (file, "\n**elset poly%d\n", PrintedElset);
      col = 0;
      (*pPolyEltQty)[0]++;
    }

    (*pPolyEltQty)[elset]++;

    FPrintfWNC (file, Map.EltId[i], &col, 72);
  }
  fprintf (file, "\n");

  if (ut_string_inlist (In.format, ',', "geof"))
    fprintf (file, "\n***return\n");

  ut_file_close (file, In.geof, "A");

  return;
}

void
WriteOriIn (struct DNEIGH DNeigh, int *PolyEltQty)
{
  int i;
  int m = 0;
  FILE *file;

  file = ut_file_open (DNeigh.oin, "w");

  fprintf (file, "poisson\n");

  fprintf (file, "%d %d %d\n", DNeigh.NDensity, DNeigh.Id, PolyEltQty[0]);

  fprintf (file, "list\n");

  for (i = 1; i <= DNeigh.N; i++)
    if (PolyEltQty[i] != 0)	/* printing the ori rng id only */
      FPrintfWNC (file, i, &m, 72);	/* if the poly has got elements. */
  for (i = 1; i <= DNeigh.nN; i++)	/* else, it must not be printed. */
    if (PolyEltQty[i + DNeigh.N] != 0)	/* the same... */
      FPrintfWNC (file, DNeigh.nGermRandId[i], &m, 72);

  ut_file_close (file, DNeigh.oin, "w");

  return;
}


