/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2010, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"RandDistrib.h"

/* IniVariables initializes the program variables related to the 
 * previously loaded input data and internal parameters. They are
 * described in the mp.h file. */
void
RandDistrib (struct GERMSET *pGermSet, double *size, int ps2d)
{
  /* Initializing the variable: Random */
  (*pGermSet).Random = neut_rand_nnid2rand ((*pGermSet).N, (*pGermSet).Id);

  if ((*pGermSet).ttype == 2)
  {
    (*pGermSet).NDensity = (double) (*pGermSet).N;
    (*pGermSet).N =
      neut_rand_poisson ((*pGermSet).NDensity, (int) (*pGermSet).Random, 1);
  }

  /* IniGermsCoo initializes the variable: GermsCoo */
  (*pGermSet).GermsCoo = ut_alloc_2d ((*pGermSet).N + 1, 4);

  IniGermsCoo ((*pGermSet).N, (*pGermSet).Random,
	       ps2d, size, (*pGermSet).GermsCoo);

  return;
}

void
DistribFromFile (struct IN In, struct GERMSET *pGermSet)
{
  FILE *file = ut_file_open (In.centrecoo, "r");
  int i, j;

  (*pGermSet).GermsCoo = ut_alloc_2d ((*pGermSet).N + 1, 4);

  for (i = 1; i <= (*pGermSet).N; i++)
    for (j = 1; j <= 3; j++)
      fscanf (file, "%lf", &((*pGermSet).GermsCoo[i][j]));

  ut_file_close (file, In.centrecoo, "r");

  return;
}
