/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2010, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"RandDistrib.h"
#include<gsl/gsl_rng.h>

/* IniGermsCoo initializes the variable: GermsCoo */
void
IniGermsCoo (int N, int Random, int ps2d, double *size, double **GermsCoo)
{
  int i, j;
  gsl_rng *r;

  /* random number generator initialization */
  r = gsl_rng_alloc (gsl_rng_ranlxd2);
  gsl_rng_set (r, Random);

  /* GermsCoo is filled line by line. */
  for (i = 1; i <= N; i++)
    for (j = 1; j <= 3; j++)
      GermsCoo[i][j] =
	size[2 * j - 1] + gsl_rng_uniform (r) * (size[2 * j] -
						 size[2 * j - 1]);

  /* in the case of ps2d tessellation, setting all z to 0 */
  if (ps2d == 1)
    for (i = 1; i <= N; i++)
      GermsCoo[i][3] = (size[6] - size[5]) / 2;

  gsl_rng_free (r);

  return;
}
