/* This file is part of the 'neper' program. */
/* Copyright (C) 2003-2010, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "neut_geo_fscanf.h"

void
neut_geo_fscanf (FILE* file, struct GEO* pGeo)
{
  GIHead (pGeo, file);
  GIVer (pGeo, file);
  GIEdge (pGeo, file);
  GIFace (pGeo, file);
  GIPoly (pGeo, file);
  GIFoot (file);

  neut_geo_init_edgelength (pGeo);
  neut_geo_init_boundingbox (pGeo);

  if (neut_geo_test (*pGeo) != 0)
  {
    ut_print_message (2, 0, "The tessellation is invalid.\n");
    abort ();
  }

  return;
}
